import java.util.*;

class Etudiant {
    String nom;
    String prenom;
    int note;
    
    public Etudiant( String nom, String prenom, int note ) {
        this.nom = nom;
        this.prenom = prenom;
        this.note = note;
    }
    
    public String toString() {
        return "Etudiant:" + nom + " " + prenom + ":" + note;
    }
}


class EtudiantNomComparator implements Comparator {

    public int compare(Object o1, Object o2) {
        String nom1 = ((Etudiant)o1).nom;
        String nom2 = ((Etudiant)o2).nom;
        return nom1.compareTo( nom2 );
    }

}


class EtudiantPrenomComparator implements Comparator {

    public int compare(Object o1, Object o2) {
        String prenom1 = ((Etudiant)o1).prenom;
        String prenom2 = ((Etudiant)o2).prenom;
        return prenom1.compareTo( prenom2 );
    }

}


class EtudiantNoteComparator implements Comparator {

    public int compare(Object o1, Object o2) {
        String nom1 = ((Etudiant)o1).nom;
        String nom2 = ((Etudiant)o2).nom;
        return nom1.compareTo( nom2 );
    }

}

public class EtudiantDemo {

    public static void printTab( Etudiant tab[] ) {
        for( int i=0; i<tab.length; i++ )
            System.out.println("["+i+"] = " + tab[i] );
    }

    public static void main( String args[] ) {
        Etudiant tab[] = new Etudiant[10];
        tab[0] = new Etudiant("Bergeron", "Etienne", 1 );
        tab[1] = new Etudiant("Vaucher", "Jean", 74 );
        tab[2] = new Etudiant("Lajeunesse", "Bozo", 76 );
        tab[3] = new Etudiant("Ticoune", "Joe", 29 );
        tab[4] = new Etudiant("Dalton", "Joe", 31 );
        tab[5] = new Etudiant("Lucky", "Luke", 15 );
        tab[6] = new Etudiant("William", "Smith", 97 );
        tab[7] = new Etudiant("Dion", "Celine", 34 );
        tab[8] = new Etudiant("Lenoir", "Zorro", 12);
        tab[9] = new Etudiant("LeGrand", "Alexandre", 67 );

	Arrays.sort( tab, new EtudiantNomComparator() );
        System.out.println("-- NOM --");
        printTab( tab );

	Arrays.sort( tab, new EtudiantPrenomComparator() );
        System.out.println("-- PRENOM --");
        printTab( tab );

	Arrays.sort( tab, new EtudiantNoteComparator() );
        System.out.println("-- NOTE --");
        printTab( tab );
    }
}
